import java.awt.*;
import java.awt.event.*;
/**Einfaches Anzeigefenster fr Infos.
 * @author Oliver Barta
 * @version 1.0
 */
public class About extends Dialog implements WindowListener, ActionListener{
    private Label page;
    private int pagenumber;
    private String[][] contents;
    private int breite;
    private int hoheproeintrag;
    private boolean centertext;
    /**Erzeugt ein neues Fenster und zeigt dieses an.
     * @param owner Besitzer dieses Dialogs
     * @param title Titel des Fensters
     * @param modal blockiert die Eingabe in andere Fenster eines Programms
     * @param contents seitenweise und zeilenweise Angabe der anzuzeigenden Info
     * @param breite Breite des Fensters
     * @param hoheproeintrag Hhe pro Zeile
     * @param page Seite, die anfangs angezeigt werden soll
     */
    public About(Frame owner, String title, boolean modal, String[][] contents, int breite, int hoheproeintrag, int page, boolean centertext){
        super(owner, title, modal);
        if(contents != null)
            this.contents = contents;
        else
            this.contents = new String[0][0];
        this.breite = breite;
        this.hoheproeintrag = hoheproeintrag;
        this.centertext = centertext;
        if((page < contents.length) && (page > 0))
            this.pagenumber = page-1;
        else
            this.pagenumber = 0;
        this.addWindowListener(this);
        this.setLayout(new GridLayout(0,1,0,10));
        this.setBackground(SystemColor.control);
        this.setText();
    }
    private void setText(){
        this.removeAll();
        this.setSize(this.breite, this.hoheproeintrag*this.contents[this.pagenumber].length+80);
        this.setLocation((this.getToolkit().getScreenSize().width-this.breite)/2, (this.getToolkit().getScreenSize().height-this.hoheproeintrag*this.contents[this.pagenumber].length-80)/2);
        this.add(new Label());
        for(int i = 0; i < this.contents[this.pagenumber].length; i++){
            Label label = new Label(this.contents[this.pagenumber][i]);
            if(this.centertext)
                label.setAlignment(Label.CENTER);
            this.add(label);
        }
        if(this.contents.length > 1){
            Panel buttons = new Panel(new GridLayout(1, 0, 5, 0));
            buttons.add(new Label());
            if(this.pagenumber != 0){
                Button back = new Button("<<");
                back.setActionCommand("previous");
                back.addActionListener(this);
                buttons.add(back);
            }else
                buttons.add(new Label());
            buttons.add(new Label());
            this.page = new Label((this.pagenumber+1)+" / "+this.contents.length);
            this.page.setAlignment(Label.CENTER);
            buttons.add(this.page);
            buttons.add(new Label());
            if(this.pagenumber != this.contents.length-1){
                Button next = new Button(">>");
                next.setActionCommand("next");
                next.addActionListener(this);
                buttons.add(next);
            }else
                buttons.add(new Label());
            buttons.add(new Label());
            this.add(buttons);
        }
        this.setVisible(true);
    }
    public void actionPerformed(ActionEvent ae){
        if(ae.getActionCommand().equalsIgnoreCase("next")){
            this.pagenumber++;
            if(this.pagenumber >= this.contents.length)
                this.pagenumber = 0;
            this.setText();
        }
        else if(ae.getActionCommand().equalsIgnoreCase("previous")){
            this.pagenumber--;
            if(this.pagenumber < 0)
                this.pagenumber = this.contents.length-1;
            this.setText();
        }
    }
    /**Schliet dieses Infofenster.
     * @param we wird nicht ausgewertet
     */
    public void windowClosing(WindowEvent we){
        this.setVisible(false);
        this.dispose();
    }
    /**leer*/
    public void windowDeactivated(WindowEvent we){}
    /**leer*/
    public void windowActivated(WindowEvent we){}
    /**leer*/
    public void windowDeiconified(WindowEvent we){}
    /**leer*/
    public void windowIconified(WindowEvent we){}
    /**leer*/
    public void windowClosed(WindowEvent we){}
    /**leer*/
    public void windowOpened(WindowEvent we){}
}
