/**Dies ist eine Hilfsklasse zum Konvertieren von Strings in Zahlen.
 * @author Oliver Barta
 * @version 1.0
 */
public class Converter{
    /**Findet eine bestimmte Zeichenkette in einem String und konvertiert diese in eine Zahl
     * @param input Eingabestring
     * @param offset Index bei dem mit der Suche begonnen werden soll
     * @param prefix Zeichenkette, die unmittelbar vor der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param suffix Zeichenkette, die unmittelbar nach der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param alternative Rckgabewert, der verwendet werden soll, wenn die gesuchte Zeichenkette nicht gefungen wird oder ein anderer Fehler auftritt
     * @return konvertierte Zahl oder, falls ein Fehler aufgetreten ist, der Alternativwert
     */
    public static double parseDouble(String input, int offset, String prefix, String suffix, double alternative){
        int start = input.indexOf(prefix, offset);
        if(start < 0)
            return alternative;
        start += prefix.length();
        int end = input.indexOf(suffix, start);
        if(end < 0)
            end = input.length();
        try{
            return Double.parseDouble(input.substring(start, end));
        }catch(Exception e){};
        return alternative;
    }
    /**Findet eine bestimmte Zeichenkette in einem String und konvertiert diese in eine Zahl
     * @param input Eingabestring
     * @param offset Index bei dem mit der Suche begonnen werden soll
     * @param prefix Zeichenkette, die unmittelbar vor der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param suffix Zeichenkette, die unmittelbar nach der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param alternative Rckgabewert, der verwendet werden soll, wenn die gesuchte Zeichenkette nicht gefungen wird oder ein anderer Fehler auftritt
     * @return konvertierte Zahl oder, falls ein Fehler aufgetreten ist, der Alternativwert
     */
    public static int parseInt(String input, int offset, String prefix, String suffix, int alternative){
        int start = input.indexOf(prefix, offset);
        if(start < 0)
            return alternative;
        start += prefix.length();
        int end = input.indexOf(suffix, start);
        if(end < 0)
            end = input.length();
        try{
            return Integer.parseInt(input.substring(start, end));
        }catch(Exception e){};
        return alternative;
    }
    /**Findet eine bestimmte Zeichenkette in einem String und konvertiert diese in eine Zahl
     * @param input Eingabestring
     * @param offset Index bei dem mit der Suche begonnen werden soll
     * @param prefix Zeichenkette, die unmittelbar vor der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param suffix Zeichenkette, die unmittelbar nach der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param alternative Rckgabewert, der verwendet werden soll, wenn die gesuchte Zeichenkette nicht gefungen wird oder ein anderer Fehler auftritt
     * @return konvertierte Zahl oder, falls ein Fehler aufgetreten ist, der Alternativwert
     */
    public static float parseFloat(String input, int offset, String prefix, String suffix, float alternative){
        int start = input.indexOf(prefix, offset);
        if(start < 0)
            return alternative;
        start += prefix.length();
        int end = input.indexOf(suffix, start);
        if(end < 0)
            end = input.length();
        try{
            return Float.parseFloat(input.substring(start, end));
        }catch(Exception e){};
        return alternative;
    }
    /**Findet eine bestimmte Zeichenkette in einem String und konvertiert diese in eine Zahl
     * @param input Eingabestring
     * @param offset Index bei dem mit der Suche begonnen werden soll
     * @param prefix Zeichenkette, die unmittelbar vor der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param suffix Zeichenkette, die unmittelbar nach der gesuchten Zahl steht und nicht mitkonvertiert werden soll
     * @param alternative Rckgabewert, der verwendet werden soll, wenn die gesuchte Zeichenkette nicht gefungen wird oder ein anderer Fehler auftritt
     * @return konvertierte Zahl oder, falls ein Fehler aufgetreten ist, der Alternativwert
     */
    public static boolean parseBoolean(String input, int offset, String prefix, String suffix, boolean alternative){
        int start = input.indexOf(prefix, offset);
        if(start < 0)
            return alternative;
        start += prefix.length();
        int end = input.indexOf(suffix, start);
        if(end < 0)
            end = input.length();
        try{
            return Boolean.parseBoolean(input.substring(start, end));
        }catch(Exception e){};
        return alternative;
    }
}
