import java.util.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;
import javax.vecmath.*;
/**
 * @author Oliver Barta
 * @version 1.0
 */
public class EEmitter extends Charge{
    public EEmitter(EFeld efeld, double x, double y, double z, double breite, double hohe, Color3f color, boolean emitting, Vector3d ausrichtung, Vector3d ausrichtungoben){
        super(efeld, 0, x, y, z, breite, hohe, breite, color, emitting, ausrichtung, ausrichtungoben);
        this.specification = "Electron emitter";
    }
    public EEmitter(EFeld efeld, String loadString){
        this(efeld, Converter.parseDouble(loadString, 0, "x = ", " ", 0.), Converter.parseDouble(loadString, 0, "y = ", " ", 0.), Converter.parseDouble(loadString, 0, "z = ", " ", 0.), Converter.parseDouble(loadString, 0, "a = ", " ", 1.), Converter.parseDouble(loadString, 0, "b = ", " ", .1), new Color3f(Converter.parseFloat(loadString, 0, "R = ", " ", 1f),Converter.parseFloat(loadString, 0, "G = ", " ", 1f),Converter.parseFloat(loadString, 0, "B = ", " ", 0f)),Converter.parseBoolean(loadString, 0, "emit = ", " ", false), new Vector3d(Converter.parseDouble(loadString, 0, "fx = ", " ", 0.),Converter.parseDouble(loadString, 0, "fy = ", " ", 0.),Converter.parseDouble(loadString, 0, "fz = ", " ", -1.)), new Vector3d(Converter.parseDouble(loadString, 0, "ux = ", " ", 0.),Converter.parseDouble(loadString, 0, "uy = ", " ", 1.),Converter.parseDouble(loadString, 0, "uz = ", " ", 0.)));
    }
    /**Setzt die Ladung auf null
     * @param QinAs Ladung (wird nicht ausgewertet)
     * @return false
     */
    public boolean setCharge(double QinAs){
        super.setCharge(0);
        return false;
    }
    public Vektor3D getField(Vektor3D position){
        return new Vektor3D();
    }
    /**
     * @return {true,true,false}
     */
    public boolean[] setScale(Vector3d scale){
        boolean[] suc = super.setScale(new Vector3d(scale.x,scale.y,scale.x));
        suc[2] = false;
        return suc;
    }
    public void addElectrons(){
        if(this.emitting)
            if(Math.random()*20 < efeld.timestep_nano){
                double winkel = Math.random()*2*Math.PI;
                double radius = Math.random()/2;
                Vector3d pos_vector = new Vector3d(Math.cos(winkel)*radius,0.0,Math.sin(winkel)*radius);
                this.transformrot.transform(pos_vector);
                Vector3d v_vector = new Vector3d(0,1E8,0);
                this.transformrot.transform(v_vector);
                this.efeld.addCharge(new Elektron(this.efeld, this.pos.x+pos_vector.x, this.pos.y+pos_vector.y, this.pos.z+pos_vector.z, v_vector.x, v_vector.y, v_vector.z));
            }
    }
    /**leer
     * @return null
     */
    public Vector prepareMove(Vector elektrons, double timestep){
        return null;
    }
    public BranchGroup createVisibleObjekt(){
        Appearance appearance = new Appearance();
        appearance.setMaterial(new Material(this.originalcolor, new Color3f(), new Color3f(), this.originalcolor, 1f));
        Cylinder cylinder = new Cylinder(0.5f, 1f, appearance);
        BranchGroup group = new BranchGroup();
        group.addChild(cylinder);
        return group;
    }
    /**leer
     * @return null
     */
    public double[][] getFieldlineStartingPoints(int count){
        return null;
    }
    /**leer
     * @return false
     */
    public boolean collided(Vektor3D position, double radius, int precision){
        return false;
    }
    public String getSaveString(){
        return (this.specification+" x = "+this.pos.x+" y = "+this.pos.y+" z = "+this.pos.z+" a = "+this.breite+" b = "+this.hohe+" R = "+this.originalcolor.x+" G = "+this.originalcolor.y+" B = "+this.originalcolor.z+" emit = "+this.originalemitting+" fx = "+this.drehung.x+" fy = "+this.drehung.y+" fz = "+this.drehung.z+" ux = "+this.drehungoben.x+" uy = "+this.drehungoben.y+" uz = "+this.drehungoben.z);
    }
}
