import java.awt.*;
import java.awt.event.*;
/**Diese Klasse beinhaltet das Menu des Hauptfensters von EFeld.
 * @author Oliver Barta
 * @version 1.0
 */
public class EFeldMenu extends MenuBar{
    private EFeld efeld;
    private Menu m_program;
        private MenuItem mi_pause;
        private MenuItem mi_save;
        private MenuItem mi_load;
        private MenuItem mi_addload;
        private MenuItem mi_exit;
    private Menu m_option;
        private CheckboxMenuItem mi_fieldlinesvisible;
        private Menu m_bounds;
            private CheckboxMenuItem mi_boundsvisible;
            private MenuItem mi_increasebounds;
            private MenuItem mi_decreasebounds;
        private Menu m_sprache;
            private MenuItem mi_deutsch;
            private MenuItem mi_englisch;
        private MenuItem mi_saveoption;
        private MenuItem mi_loadoption;
        private MenuItem mi_clearoption;
    private Menu m_window;
        private CheckboxMenuItem mi_objectframeshow;
        private CheckboxMenuItem mi_timeframeshow;
    private Menu m_help;
        private MenuItem mi_help;
        private MenuItem mi_about;
    /**Erzeugt eine neue Instanz dieser Klasse
     * @param efeld EFeld (Zugehriges EFeld-Fenster)
     */
    public EFeldMenu(EFeld efeld){
        this.efeld = efeld;
        //Programm
        this.m_program = new Menu();
        this.m_program.addActionListener(efeld);

        //Pause
        this.mi_pause = new MenuItem();
        this.mi_pause.setActionCommand("Pause");
        this.m_program.add(this.mi_pause);

        //Save
        this.mi_save = new MenuItem();
        this.mi_save.setActionCommand("SaveScene");
        this.m_program.add(this.mi_save);

        //Load
        this.mi_load = new MenuItem();
        this.mi_load.setActionCommand("LoadScene");
        this.m_program.add(this.mi_load);

        //AddLoad
        this.mi_addload = new MenuItem();
        this.mi_addload.setActionCommand("AddLoadScene");
        this.m_program.add(this.mi_addload);

        //Exit
        this.mi_exit = new MenuItem();
        this.mi_exit.setActionCommand("Exit");
        this.m_program.add(this.mi_exit);

        this.add(this.m_program);

        //Option
        this.m_option = new Menu();
        this.m_option.addActionListener(efeld);

        this.mi_fieldlinesvisible = new CheckboxMenuItem();
        this.mi_fieldlinesvisible.setName("FieldLinesVisible");
        this.mi_fieldlinesvisible.addItemListener(efeld);

        //Bounds
        this.m_bounds = new Menu();
        this.m_bounds.addActionListener(efeld);

        //Bounds visible
        this.mi_boundsvisible = new CheckboxMenuItem();
        this.mi_boundsvisible.setName("BoundsVisible");
        this.mi_boundsvisible.addItemListener(efeld);

        //Bounds increase
        this.mi_increasebounds = new MenuItem();
        this.mi_increasebounds.setActionCommand("BoundsIncrease");

        //Bounds decrease
        this.mi_decreasebounds = new MenuItem();
        this.mi_decreasebounds.setActionCommand("BoundsDecrease");

        //Sprache
        this.m_sprache = new Menu();
        this.m_sprache.addActionListener(efeld);

        //Deutsch
        this.mi_deutsch = new MenuItem();
        this.mi_deutsch.setActionCommand("Deutsch");

        //Englisch
        this.mi_englisch = new MenuItem();
        this.mi_englisch.setActionCommand("Englisch");

        //Save Option
        this.mi_saveoption = new MenuItem();
        this.mi_saveoption.setActionCommand("saveOption");

        //Load Option
        this.mi_loadoption = new MenuItem();
        this.mi_loadoption.setActionCommand("loadOption");

        //Clear Option
        this.mi_clearoption = new MenuItem();
        this.mi_clearoption.setActionCommand("clearOption");

        this.m_option.add(this.mi_fieldlinesvisible);
        this.m_bounds.add(this.mi_boundsvisible);
        this.m_bounds.add(this.mi_increasebounds);
        this.m_bounds.add(this.mi_decreasebounds);
        this.m_option.add(this.m_bounds);
        this.m_option.addSeparator();
        this.m_sprache.add(this.mi_deutsch);
        this.m_sprache.add(this.mi_englisch);
        this.m_option.add(this.m_sprache);
        this.m_option.addSeparator();
        this.m_option.add(this.mi_saveoption);
        this.m_option.add(this.mi_loadoption);
        this.m_option.add(this.mi_clearoption);

        this.add(this.m_option);

        //Window
        this.m_window = new Menu();
        this.m_window.addActionListener(efeld);

        //Time window visible
        this.mi_timeframeshow = new CheckboxMenuItem();
        this.mi_timeframeshow.addItemListener(efeld);
        this.mi_timeframeshow.setName("TimeFrameShow");

        //Object window visible
        this.mi_objectframeshow = new CheckboxMenuItem();
        this.mi_objectframeshow.addItemListener(efeld);
        this.mi_objectframeshow.setName("ObjectFrameShow");

        this.m_window.add(this.mi_objectframeshow);
        this.m_window.add(this.mi_timeframeshow);

        this.add(this.m_window);

        //Help
        this.m_help = new Menu();
        this.m_help.addActionListener(efeld);

        //Help
        this.mi_help = new MenuItem();
        this.mi_help.setActionCommand("Help");
        this.m_help.add(this.mi_help);

        //About
        this.mi_about = new MenuItem();
        this.mi_about.setActionCommand("About");
        this.m_help.add(this.mi_about);

        this.add(this.m_help);

        this.applyOption();
    }
    /**Setzt die Option fr dieses Men praktisch um (inklusive setLabels()).*/
    public void applyOption(){
        this.mi_timeframeshow.setState(this.efeld.timeframevisible);
        this.mi_boundsvisible.setState(this.efeld.boundingvisible);
        this.mi_fieldlinesvisible.setState(this.efeld.fieldlinesvisible);
        this.mi_objectframeshow.setState(this.efeld.objectframevisible);
        this.setLabels(this.efeld.country);
    }
    /**Setzt alle Beschriftungen dieses Mens in der bergebenen Sprache oder in Englisch falls die Sprache nicht untersttzt wird.
     * @param language gewnschte Sprache*/
    public void setLabels(String language){
        String program = "Program";
        String exit = "Exit";
        String save = "Save as ...";
        String load = "Load ...";
        String addload = "Add ...";
        String option = "Option";
        String sprache = "Language";
        String deutsch = "Deutsch";
        String englisch = "English";
        String saveoption = "Save option";
        String loadoption = "Load option";
        String clearoption = "Restore default option";
        String window = "Window";
        String timeframeshow = "Show Time Window";
        String bounds = "Computing bounds";
        String boundsvisible = "Bounds visible";
        String boundsincrease = "Increase bounds";
        String boundsdecrease = "Decrease bounds";
        String objectframeshow = "Show object manager";
        String fieldlinesvisible = "Field lines visible";
        String help = "Help";
        String about = "About";
        if((language != null) && (language.equalsIgnoreCase("DE"))){
            program = "Programm";
            exit = "Ende";
            save = "Speichern unter ...";
            load = "Laden ...";
            addload = "Hinzufgen ...";
            option = "Einstellungen";
            sprache = "Sprache";
            saveoption = "Einstellungen speichern";
            loadoption = "Einstellungen laden";
            clearoption = "Standardeinstellungen wiederherstellen";
            window = "Fenster";
            timeframeshow = "Zeitfenster anzeigen";
            bounds = "Rechenbereich";
            boundsvisible = "Bereich anzeigen";
            boundsincrease = "Bereich vergrern";
            boundsdecrease = "Bereich verkleinern";
            objectframeshow = "Objektmanager anzeigen";
            fieldlinesvisible = "Feldlinien anzeigen";
            help = "Hilfe";
            about = "Info";
        }
        this.m_program.setLabel(program);
        this.mi_exit.setLabel(exit);
        this.mi_save.setLabel(save);
        this.mi_load.setLabel(load);
        this.mi_addload.setLabel(addload);
        this.m_option.setLabel(option);
        this.m_sprache.setLabel(sprache);
        this.mi_deutsch.setLabel(deutsch);
        this.mi_englisch.setLabel(englisch);
        this.mi_saveoption.setLabel(saveoption);
        this.mi_loadoption.setLabel(loadoption);
        this.mi_clearoption.setLabel(clearoption);
        this.m_window.setLabel(window);
        this.mi_timeframeshow.setLabel(timeframeshow);
        this.setPauseLabel(language);
        this.m_bounds.setLabel(bounds);
        this.mi_boundsvisible.setLabel(boundsvisible);
        this.mi_fieldlinesvisible.setLabel(fieldlinesvisible);
        this.mi_increasebounds.setLabel(boundsincrease);
        this.mi_decreasebounds.setLabel(boundsdecrease);
        this.mi_objectframeshow.setLabel(objectframeshow);
        this.m_help.setLabel(help);
        this.mi_about.setLabel(about);
        this.mi_help.setLabel(help);
    }
    /**Setzt das aktuelle Pauselabel
     * @param language Sprache
     */
    public void setPauseLabel(String language){
        String pause[] = {"Break", "Resume"};
        if((language != null) && (language.equalsIgnoreCase("DE"))){
            pause[0] = "Pause";
            pause[1] = "Weiter";
        }
        if(this.efeld.pause)
            this.mi_pause.setLabel(pause[1]);
        else
            this.mi_pause.setLabel(pause[0]);
    }
}
