import java.util.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;
import javax.vecmath.*;
/**
 * @author Oliver Barta
 * @version 1.0
 */
public class LineCharge extends Charge{
    public LineCharge(EFeld efeld, double QinAs, double x, double y, double z, double breite, double lange, Color3f color, boolean emitting, Vector3d ausrichtung, Vector3d ausrichtungoben){
        super(efeld, QinAs, x, y, z, breite, lange, breite, color, emitting, ausrichtung, ausrichtungoben);
        this.specification = "Static LineCharge";
    }
    public LineCharge(EFeld efeld, String loadString){
        this(efeld, Converter.parseDouble(loadString, 0, "Q = ", " ", 0.), Converter.parseDouble(loadString, 0, "x = ", " ", 0.), Converter.parseDouble(loadString, 0, "y = ", " ", 0.), Converter.parseDouble(loadString, 0, "z = ", " ", 0.), Converter.parseDouble(loadString, 0, "a = ", " ", 1.), Converter.parseDouble(loadString, 0, "b = ", " ", 1.), new Color3f(Converter.parseFloat(loadString, 0, "R = ", " ", 1f),Converter.parseFloat(loadString, 0, "G = ", " ", 1f),Converter.parseFloat(loadString, 0, "B = ", " ", 0f)),Converter.parseBoolean(loadString, 0, "emit = ", " ", false), new Vector3d(Converter.parseDouble(loadString, 0, "fx = ", " ", 0.),Converter.parseDouble(loadString, 0, "fy = ", " ", 0.),Converter.parseDouble(loadString, 0, "fz = ", " ", -1.)), new Vector3d(Converter.parseDouble(loadString, 0, "ux = ", " ", 0.),Converter.parseDouble(loadString, 0, "uy = ", " ", 1.),Converter.parseDouble(loadString, 0, "uz = ", " ", 0.)));
    }
    public void addElectrons(){
        if(this.emitting)
            if(Math.random()*20 < efeld.timestep_nano*this.hohe/10){
                double winkel = Math.random()*2*Math.PI;
                double hohe = Math.random();
                Vector3d pos_vector = new Vector3d(Math.cos(winkel)*(this.breite/2+Elektron.radius+1E-10),this.hohe*(hohe-0.5),Math.sin(winkel)*(this.breite/2+Elektron.radius+1E-10));
                Transform3D trans = new Transform3D(this.transformrot);
                trans.setScale(1);
                trans.transform(pos_vector);
                this.efeld.addCharge(new Elektron(this.efeld, this.pos.x+pos_vector.x, this.pos.y+pos_vector.y, this.pos.z+pos_vector.z));
            }
    }
    public Vektor3D getField(Vektor3D position){
        Point3d point = new Point3d(position.x-this.pos.x,position.y-this.pos.y,position.z-this.pos.z);
        Transform3D trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.invert();
        trans.transform(point);
        double cona = Math.sqrt(4*point.x*point.x+4*point.z*point.z+(2*point.y-this.hohe)*(2*point.y-this.hohe));
        double conb = Math.sqrt(4*point.x*point.x+4*point.z*point.z+4*point.y*point.y+4*this.hohe*point.y+this.hohe*this.hohe);
        double conxz = (this.Q_As*((2*point.y+this.hohe)*cona+(this.hohe-2*point.y)*conb))/(4*Math.PI*this.hohe*8.8542E-12*(point.x*point.x+point.z*point.z)*cona*conb);
        double cony = (this.Q_As*(conb-cona))/(2*Math.PI*this.hohe*8.8542E-12*cona*conb);
        point = new Point3d(conxz*point.x,cony,conxz*point.z);
        trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.transform(point);
        return new Vektor3D(point.x,point.y,point.z);
    }
    public Vector prepareMove(Vector elektrons, double timestep){
        Vector delete = null;
        for(int i = 0; i < elektrons.size(); i++){
            if(this.collided(((Charge)elektrons.elementAt(i)).pos, Elektron.radius, 0)){
                if(delete == null)
                    delete = new Vector();
                delete.add(((Charge)elektrons.elementAt(i)));
            }
        }
        return delete;
    }
    /**
     * @return {true,true,false}
     */
    public boolean[] setScale(Vector3d scale){
        boolean[] suc = super.setScale(new Vector3d(scale.x,scale.y,scale.x));
        suc[2] = false;
        return suc;
    }
    public BranchGroup createVisibleObjekt(){
        this.setColor(this.color);
        Cylinder cylinder = new Cylinder(0.5f, 1f, this.appearance);
        BranchGroup group = new BranchGroup();
        group.addChild(cylinder);
        return group;
    }
    public double[][] getFieldlineStartingPoints(int count){
        double[][] points;
        if((this.hohe >= this.breite) && (this.hohe > 1)){
        points = new double[count][3];
        Point3d point = new Point3d();
        for(int i = 0; i < points.length; i++){
            point.set(Math.cos(i)/2,(double)i/(points.length-1)-0.5,Math.sin(i)/2);
            this.transformrot.transform(point);
            points[i][0] = this.pos.x+point.x;
            points[i][1] = this.pos.y+point.y;
            points[i][2] = this.pos.z+point.z;
        }
        }else{
        int a = (int)Math.sqrt(2*count);
        int b = (int)Math.sqrt(count/2);
        points = new double[2*a*b][3];
        for(int i = 0; i < a; i++){
            for(int ii = 0; ii < b; ii++){
                double cosa = Math.cos(2*Math.PI*(double)i/a);
                double cosb = Math.cos(Math.PI*(double)ii/(2*b));
                double sina = Math.sin(2*Math.PI*(double)i/a);
                double sinb = Math.sin(Math.PI*(double)ii/(2*b));
                points[ii+i*b][0] = this.pos.x+cosa*cosb*Math.max(this.breite,this.hohe)/2;
                points[ii+i*b][1] = this.pos.y+sinb*Math.max(this.breite,this.hohe)/2;
                points[ii+i*b][2] = this.pos.z+sina*cosb*Math.max(this.breite,this.hohe)/2;
                points[a*b+ii+i*b][0] = points[ii+i*b][0];
                points[a*b+ii+i*b][1] = this.pos.y-sinb*Math.max(this.breite,this.hohe)/2;
                points[a*b+ii+i*b][2] = points[ii+i*b][2];
            }
        }
        }
        return points;
    }
    public boolean collided(Vektor3D position, double radius, int precision){
        Point3d point = new Point3d(position.x-this.pos.x,position.y-this.pos.y,position.z-this.pos.z);
        Transform3D trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.invert();
        trans.transform(point);
        if(Math.abs(point.y) <= this.hohe/2+radius)
            if(Math.sqrt(point.x*point.x+point.z*point.z) <= radius+this.breite/2)
                return true;
        return false;
    }
    public String getSaveString(){
        return (this.specification+" Q = "+this.Q_As+" x = "+this.pos.x+" y = "+this.pos.y+" z = "+this.pos.z+" a = "+this.breite+" b = "+this.hohe+" R = "+this.originalcolor.x+" G = "+this.originalcolor.y+" B = "+this.originalcolor.z+" emit = "+this.originalemitting+" fx = "+this.drehung.x+" fy = "+this.drehung.y+" fz = "+this.drehung.z+" ux = "+this.drehungoben.x+" uy = "+this.drehungoben.y+" uz = "+this.drehungoben.z);
    }
}
