import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.vecmath.*;
/**Objektmanager des Programms EFeld.
 * @author Oliver Barta
 * @version 1.0
 */
public class ObjectManager extends Dialog implements WindowListener, ItemListener, TextListener, ActionListener{
    private EFeld efeld;
    private List objectliste;
    private TextField posx;
    private TextField posy;
    private TextField posz;
    private TextField asize;
    private TextField bsize;
    private TextField csize;
    private TextField QinAs;
    private Checkbox emitting;
    private Button delete;
    private Button deleteallobj;
    private Button deleteel;
    private Button point;
    private Button line;
    private Button plate;
    private Button emitter;
    private int selfcausedevents;
    /**Erzeugt eine neue Instanz.
     * @param efeld zugehriges EFeld Fenster
     */
    public ObjectManager(EFeld efeld){
        super(efeld);
        this.efeld = efeld;
        this.selfcausedevents = 0;
        this.addWindowListener(this);
        this.addKeyListener(efeld);
        this.setLayout(new GridLayout(0,1,0,10));
        this.setBackground(SystemColor.control);
        
        this.objectliste = new List();
        this.objectliste.setName("ObjektListe");
        this.objectliste.addItemListener(this);
        this.objectliste.addKeyListener(efeld);
        this.add(this.objectliste);

        Panel position = new Panel(new GridLayout(1, 0, 0, 0));
        position.add(new Label("x / y / z"));
        this.posx = new TextField();
        this.posx.setName("X");
        this.posx.addTextListener(this);
        this.posx.addKeyListener(efeld);
        position.add(this.posx);
        this.posy = new TextField();
        this.posy.setName("Y");
        this.posy.addTextListener(this);
        this.posy.addKeyListener(efeld);
        position.add(this.posy);
        this.posz = new TextField();
        this.posz.setName("Z");
        this.posz.addTextListener(this);
        this.posz.addKeyListener(efeld);
        position.add(this.posz);
        this.add(position);

        Panel Q_p = new Panel(new GridLayout(1, 0, 0, 0));
        Q_p.add(new Label("Q in As"));
        this.QinAs = new TextField();
        this.QinAs.setName("QinAs");
        this.QinAs.addTextListener(this);
        this.QinAs.addKeyListener(efeld);
        Q_p.add(this.QinAs);
        this.add(Q_p);

        Panel size = new Panel(new GridLayout(1, 0, 0, 0));
        size.add(new Label("a / b / c"));
        this.asize = new TextField();
        this.asize.setName("aSize");
        this.asize.addTextListener(this);
        this.asize.addKeyListener(efeld);
        size.add(this.asize);
        this.bsize = new TextField();
        this.bsize.setName("bSize");
        this.bsize.addTextListener(this);
        this.bsize.addKeyListener(efeld);
        size.add(this.bsize);
        this.csize = new TextField();
        this.csize.setName("cSize");
        this.csize.addTextListener(this);
        this.csize.addKeyListener(efeld);
        size.add(this.csize);
        this.add(size);

        Panel delete_p = new Panel(new GridLayout(1, 0, 0, 0));
        this.emitting = new Checkbox();
        this.emitting.setName("Emitting");
        this.emitting.addItemListener(this);
        this.emitting.addKeyListener(efeld);
        delete_p.add(this.emitting);
        this.delete = new Button();
        this.delete.setActionCommand("Delete");
        this.delete.addActionListener(this);
        this.delete.addKeyListener(efeld);
        delete_p.add(this.delete);
        this.add(delete_p);

        Panel delete2_p = new Panel(new GridLayout(1, 0, 0, 0));
        this.deleteallobj = new Button();
        this.deleteallobj.setActionCommand("DeleteAllObjects");
        this.deleteallobj.addActionListener(this);
        this.deleteallobj.addKeyListener(efeld);
        this.deleteel = new Button();
        this.deleteel.setActionCommand("DeleteElectrons");
        this.deleteel.addActionListener(this);
        this.deleteel.addKeyListener(efeld);
        delete2_p.add(this.deleteallobj);
        delete2_p.add(this.deleteel);
        this.add(delete2_p);

        Panel add_p = new Panel(new GridLayout(1, 0, 0, 0));
        this.point = new Button();
        this.point.setActionCommand("AddPointCharge");
        this.point.addActionListener(this);
        this.point.addKeyListener(efeld);
        add_p.add(this.point);
        this.emitter = new Button();
        this.emitter.setActionCommand("AddEmitter");
        this.emitter.addActionListener(this);
        this.emitter.addKeyListener(efeld);
        add_p.add(this.emitter);
        this.add(add_p);
        Panel add2_p = new Panel(new GridLayout(1, 0, 0, 0));
        this.line = new Button();
        this.line.setActionCommand("AddLineCharge");
        this.line.addActionListener(this);
        this.line.addKeyListener(efeld);
        add2_p.add(this.line);
        this.plate = new Button();
        this.plate.setActionCommand("AddPlateCharge");
        this.plate.addActionListener(this);
        this.plate.addKeyListener(efeld);
        add2_p.add(this.plate);
        this.add(add2_p);

        this.applyOption();
    }
    /**Aktualisiert die Anzeige von Ladung und Gre.
     */
    public void refreshValues(){
        int index = this.objectliste.getSelectedIndex();
        if(index >= 0){
            this.selfcausedevents += 4;

            int prepos = this.QinAs.getCaretPosition();
            this.QinAs.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).Q_As);
            this.QinAs.setCaretPosition(prepos);
            this.QinAs.setEnabled(true);
            if(!((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setCharge(((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).Q_As))
            this.QinAs.setEnabled(false);

            boolean[] suc = ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setScale(new Vector3d(((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).breite, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).hohe, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).tiefe));

            prepos = this.asize.getCaretPosition();
            this.asize.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).breite);
            this.asize.setCaretPosition(prepos);
            if(!suc[0])
                this.asize.setEnabled(false);
            else
                this.asize.setEnabled(true);

            prepos = this.bsize.getCaretPosition();
            this.bsize.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).hohe);
            this.bsize.setCaretPosition(prepos);
            if(!suc[1])
                this.bsize.setEnabled(false);
            else
                this.bsize.setEnabled(true);

            prepos = this.csize.getCaretPosition();
            this.csize.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).tiefe);
            this.csize.setCaretPosition(prepos);
            this.emitting.setState(((Charge)this.efeld.ladungst.elementAt(index)).originalemitting);
            if(!suc[2])
                this.csize.setEnabled(false);
            else
                this.csize.setEnabled(true);
        }
        this.refreshPositionValues();
    }
    /**Aktualisiert die Anzeige der Position.
     */
    public void refreshPositionValues(){
        int index = this.objectliste.getSelectedIndex();
        if(index >= 0){
            this.selfcausedevents += 3;

            int prepos = this.posx.getCaretPosition();
            this.posx.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).pos.x);
            this.posx.setCaretPosition(prepos);

            prepos = this.posy.getCaretPosition();
            this.posy.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).pos.y);
            this.posy.setCaretPosition(prepos);

            prepos = this.posz.getCaretPosition();
            this.posz.setText(""+((Charge)this.efeld.ladungst.elementAt(index)).pos.z);
            this.posz.setCaretPosition(prepos);
        }
    }
    /**Aktalisiert die Objektliste und ruft this.selectIndex(this.efeld.selectedobject) auf.
     * @see #selectIndex
     */
    public void refresh(){
        this.objectliste.removeAll();
        for(int i = 0; i < this.efeld.ladungst.size(); i++){
            if(((Charge)this.efeld.ladungst.elementAt(i)).specification.equalsIgnoreCase("Static PointCharge"))
                if(this.efeld.country.equalsIgnoreCase("DE"))
                    this.objectliste.add("Statische Punktladung");
                else
                    this.objectliste.add("Static point charge");
            else if(((Charge)this.efeld.ladungst.elementAt(i)).specification.equalsIgnoreCase("Electron emitter"))
                if(this.efeld.country.equalsIgnoreCase("DE"))
                    this.objectliste.add("Elektronenemitter");
                else
                    this.objectliste.add("Electron emitter");
            else if(((Charge)this.efeld.ladungst.elementAt(i)).specification.equalsIgnoreCase("Static LineCharge"))
                if(this.efeld.country.equalsIgnoreCase("DE"))
                    this.objectliste.add("Statische geladene Linie");
                else
                    this.objectliste.add("Static charged line");
            else if(((Charge)this.efeld.ladungst.elementAt(i)).specification.equalsIgnoreCase("Static PlateCharge"))
                if(this.efeld.country.equalsIgnoreCase("DE"))
                    this.objectliste.add("Statische geladene Platte");
                else
                    this.objectliste.add("Static charged plate");
            else
                this.objectliste.add(((Charge)this.efeld.ladungst.elementAt(i)).specification);
        }
        this.selectIndex(this.efeld.selectedobject);
    }
    /**Whlt einen Eintrag aus der Liste der Objekte aus und bernimmt dessen Werte.
     * @param index Index des Objeks, welches ausgewhlt werden soll
     */
    public void selectIndex(int index){
        if((index >= 0) && (index < this.objectliste.getItemCount()))
            this.objectliste.select(index);
        this.refreshValues();
    }
    /**Setzt die Option fr dieses Fenster praktisch um (inklsive setLabels()).*/
    public void applyOption(){
        this.setSize(this.efeld.objectframebreite, this.efeld.objectframehohe);
        this.setLocation(this.efeld.objectframexpos, this.efeld.objectframeypos);
        this.setLabels(this.efeld.country);
        this.setVisible(this.efeld.objectframevisible);
    }
    /**Setzt alle Beschriftungen dieses Fensters in der bergebenen Sprache oder in Englisch falls die Sprache nicht untersttzt wird.
     * @param language gewnschte Sprache
     */
    public void setLabels(String language){
        String title = "Object manager";
        String delete = "Delete object";
        String deleteallobj = "Delete all charges";
        String deleteel = "Delete all electrons";
        String emitting = "Emit electrons";
        String punkt = "Point";
        String linie = "Line";
        String plate = "Plate";
        String emitter = "Emitter";
        if((language != null) && (language.equalsIgnoreCase("DE"))){
            title = "Objektmanager";
            delete = "Objekt lschen";
            deleteallobj = "Alle Ladungen lschen";
            deleteel = "Alle Elektronen lschen";
            emitting = "Elektronen emittieren";
            punkt = "Punkt";
            linie = "Linie";
            plate = "Platte";
            emitter = "Emitter";
        }
        this.setTitle(title);
        this.delete.setLabel(delete);
        this.deleteallobj.setLabel(deleteallobj);
        this.deleteel.setLabel(deleteel);
        this.emitting.setLabel(emitting);
        this.point.setLabel(punkt);
        this.line.setLabel(linie);
        this.plate.setLabel(plate);
        this.emitter.setLabel(emitter);
    }
    /**Macht das Fenster sichtbar bzw. unsichtbar*/
    public void setVisible(boolean visible){
        if(this.isVisible()){
            this.efeld.objectframexpos = this.getLocationOnScreen().x;
            this.efeld.objectframeypos = this.getLocationOnScreen().y;
        }
        this.efeld.efeldmenu.applyOption();
        this.refresh();
        super.setVisible(visible);
        if(this.isVisible()){
            this.efeld.objectframexpos = this.getLocationOnScreen().x;
            this.efeld.objectframeypos = this.getLocationOnScreen().y;
        }
    }
    /**Verarbeitet ActionEvents aus diesem Fenster.
     * @param ae zu verarbeitendes Ereignis
     */
    public void actionPerformed(ActionEvent ae){
        if(ae.getActionCommand().equalsIgnoreCase("Delete")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            int index = this.objectliste.getSelectedIndex();
            if((index >= 0) && (index < this.efeld.ladungst.size()))
                this.efeld.deleteCharge((Charge)this.efeld.ladungst.elementAt(index));
        }else if(ae.getActionCommand().equalsIgnoreCase("DeleteAllObjects")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.deleteAllStaticCharges();
        }else if(ae.getActionCommand().equalsIgnoreCase("DeleteElectrons")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.deleteAllElectrons();
        }else if(ae.getActionCommand().equalsIgnoreCase("AddPointCharge")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.addCharge(new PointCharge(this.efeld, 0, 0, 0, 0, 0.5, new Color3f(1,1,0), false));
            this.efeld.selectedobject = this.efeld.ladungst.size()-1;
            this.refresh();
            this.selectIndex(this.efeld.selectedobject);
        }else if(ae.getActionCommand().equalsIgnoreCase("AddEmitter")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.addCharge(new EEmitter(this.efeld, 0, 0, 0, 0.5, 0.1, new Color3f(1,1,0), false, null, null));
            this.efeld.selectedobject = this.efeld.ladungst.size()-1;
            this.refresh();
            this.selectIndex(this.efeld.selectedobject);
        }else if(ae.getActionCommand().equalsIgnoreCase("AddLineCharge")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.addCharge(new LineCharge(this.efeld, 0, 0, 0, 0, 0.2, 10, new Color3f(0,1,0), false, null, null));
            this.efeld.selectedobject = this.efeld.ladungst.size()-1;
            this.refresh();
            this.selectIndex(this.efeld.selectedobject);
        }else if(ae.getActionCommand().equalsIgnoreCase("AddPlateCharge")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.addCharge(new PlateCharge(this.efeld, 0, 0, 0, 0, 10, new Color3f(0,1,0), false, null, null));
            this.efeld.selectedobject = this.efeld.ladungst.size()-1;
            this.refresh();
            this.selectIndex(this.efeld.selectedobject);
        }
    }
    /**Verarbeitet TextEvents aus diesem Fenster
     * @param te zu verarbeitendes Textereignis
     */
    public void textValueChanged(TextEvent te){
        if(this.selfcausedevents <= 0){
        if(((TextField)te.getSource()).getName().equalsIgnoreCase("X")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newx = 0;
            try{
                this.posx.setBackground(SystemColor.text);
                newx = Double.parseDouble(this.posx.getText());
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).pos.x = newx;
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.posx.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("Y")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newy = 0;
            try{
                this.posy.setBackground(SystemColor.text);
                newy = Double.parseDouble(this.posy.getText());
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).pos.y = newy;
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.posy.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("Z")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newz = 0;
            try{
                this.posz.setBackground(SystemColor.text);
                newz = Double.parseDouble(this.posz.getText());
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).pos.z = newz;
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.posz.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("QinAs")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newq = 0;
            try{
                this.QinAs.setBackground(SystemColor.text);
                newq = Double.parseDouble(this.QinAs.getText());
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setCharge(newq);
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.QinAs.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("aSize")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newa = 0;
            try{
                this.asize.setBackground(SystemColor.text);
                newa = Double.parseDouble(this.asize.getText());
                if(newa <= 0)
                    throw new Exception();
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setScale(new Vector3d(newa, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).hohe, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).tiefe));
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.asize.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("bSize")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newb = 0;
            try{
                this.bsize.setBackground(SystemColor.text);
                newb = Double.parseDouble("+"+this.bsize.getText());
                if(newb <= 0)
                    throw new Exception();
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setScale(new Vector3d(((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).breite, newb, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).tiefe));
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.bsize.setBackground(new Color(255,0,0));
            }
        }else if(((TextField)te.getSource()).getName().equalsIgnoreCase("cSize")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            double newc = 0;
            try{
                this.csize.setBackground(SystemColor.text);
                newc = Double.parseDouble("+"+this.csize.getText());
                if(newc <= 0)
                    throw new Exception();
                if(this.objectliste.getSelectedIndex() >= 0){
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setScale(new Vector3d(((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).breite, ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).hohe, newc));
                    ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).refreshTransform();
                    this.efeld.applyFieldlines();
                }
            }catch(Exception e){
                this.csize.setBackground(new Color(255,0,0));
            }
        }
        }else
            this.selfcausedevents--;
    }
    /**Verarbeitet ItemEvents aus diesem Fenster.
     * @param ie zu verarbeitendes ItemEvent
     */
    public void itemStateChanged(ItemEvent ie){
        if(((Component)ie.getSource()).getName().equalsIgnoreCase("ObjektListe")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            this.efeld.selectedobject = this.objectliste.getSelectedIndex();
            this.refreshValues();
        }else if(((Component)ie.getSource()).getName().equalsIgnoreCase("Emitting")){
            if(this.efeld.autochange){
                this.efeld.autochange = false;
                this.efeld.setLabels(this.efeld.country);
            }
            if(this.objectliste.getSelectedIndex() >= 0)
                ((Charge)this.efeld.ladungst.elementAt(this.objectliste.getSelectedIndex())).setEmitting(this.emitting.getState());
        }
    }
    /**Macht dieses Fenster unsichtbar*/
    public void windowClosing(WindowEvent we){
        this.efeld.objectframevisible = false;
        this.setVisible(false);
    }
    /**leer*/
    public void windowDeactivated(WindowEvent we){}
    /**leer*/
    public void windowActivated(WindowEvent we){}
    /**leer*/
    public void windowDeiconified(WindowEvent we){}
    /**leer*/
    public void windowIconified(WindowEvent we){}
    /**leer*/
    public void windowClosed(WindowEvent we){}
    /**leer*/
    public void windowOpened(WindowEvent we){}
}
