import java.util.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;
import javax.vecmath.*;
/**
 * @author Oliver Barta
 * @version 1.0
 */
public class PlateCharge extends Charge{
    private double qcon;
    public PlateCharge(EFeld efeld, double QinAs, double x, double y, double z, double breite, Color3f color, boolean emitting, Vector3d ausrichtung, Vector3d ausrichtungoben){
        super(efeld, QinAs, x, y, z, breite, 20, 0.001, color, emitting, ausrichtung, ausrichtungoben);
        this.specification = "Static PlateCharge";
    }
    public PlateCharge(EFeld efeld, String loadString){
        this(efeld, Converter.parseDouble(loadString, 0, "Q = ", " ", 0.), Converter.parseDouble(loadString, 0, "x = ", " ", 0.), Converter.parseDouble(loadString, 0, "y = ", " ", 0.), Converter.parseDouble(loadString, 0, "z = ", " ", 0.), Converter.parseDouble(loadString, 0, "a = ", " ", 1.), new Color3f(Converter.parseFloat(loadString, 0, "R = ", " ", 1f),Converter.parseFloat(loadString, 0, "G = ", " ", 1f),Converter.parseFloat(loadString, 0, "B = ", " ", 0f)),Converter.parseBoolean(loadString, 0, "emit = ", " ", false), new Vector3d(Converter.parseDouble(loadString, 0, "fx = ", " ", 0.),Converter.parseDouble(loadString, 0, "fy = ", " ", 0.),Converter.parseDouble(loadString, 0, "fz = ", " ", -1.)), new Vector3d(Converter.parseDouble(loadString, 0, "ux = ", " ", 0.),Converter.parseDouble(loadString, 0, "uy = ", " ", 1.),Converter.parseDouble(loadString, 0, "uz = ", " ", 0.)));
    }
    public void addElectrons(){
        if(this.emitting)
            if(Math.random() < efeld.timestep_nano*this.breite){
            Vector3d pos_vector = new Vector3d();
                if(Math.random() > 0.5)
                    pos_vector.set(Math.random()*this.breite-this.breite/2,Math.random()*this.hohe-this.hohe/2,Elektron.radius);
                else
                    pos_vector.set(Math.random()*this.breite-this.breite/2,Math.random()*this.hohe-this.hohe/2,-Elektron.radius);
                Transform3D trans = new Transform3D(this.transformrot);
                trans.setScale(1);
                trans.transform(pos_vector);
                this.efeld.addCharge(new Elektron(this.efeld, this.pos.x+pos_vector.x, this.pos.y+pos_vector.y, this.pos.z+pos_vector.z));
            }
    }
    public boolean setCharge(double QinAs){
        boolean suc = super.setCharge(QinAs);
        this.qcon = this.Q_As/(4.*Math.PI*8.8542E-12);
        return suc;
    }
    public Vektor3D getField(Vektor3D position){
        Point3d point = new Point3d(position.x-this.pos.x,position.y-this.pos.y,position.z-this.pos.z);
        Transform3D trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.invert();
        trans.transform(point);
        point = new Point3d(-(this.qcon/this.breite)*Math.log((4*(point.z*point.z+point.x*point.x-this.breite*point.x)+this.breite*this.breite)/(4*(point.z*point.z+point.x*point.x+this.breite*point.x)+this.breite*this.breite)),
                0,
                (this.qcon*2/this.breite)*(Math.atan((2*point.x+this.breite)/(2*point.z))-Math.atan((2*point.x-this.breite)/(2*point.z))));
        trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.transform(point);
        return new Vektor3D(point.x,point.y,point.z);
    }
    public Vector prepareMove(Vector elektrons, double timestep){
        Vector delete = null;
        for(int i = 0; i < elektrons.size(); i++){
            if(this.collided(((Charge)elektrons.elementAt(i)).pos, Elektron.radius, 0)){
                if(delete == null)
                    delete = new Vector();
                delete.add(((Charge)elektrons.elementAt(i)));
            }
        }
        return delete;
    }
    /**
     * @return {true,false,false}
     */
    public boolean[] setScale(Vector3d scale){
        boolean[] suc = super.setScale(new Vector3d(scale.x,5*this.efeld.computingarea,0.001));
        suc[1] = false;
        suc[2] = false;
        return suc;
    }
    public BranchGroup createVisibleObjekt(){
        this.setColor(this.color);
        Box box = new Box(0.5f, 0.5f, 0.5f, this.appearance);
        BranchGroup group = new BranchGroup();
        group.addChild(box);
        return group;
    }
    public double[][] getFieldlineStartingPoints(int count){
        double[][] points = null;
        if(this.breite >= 1){
            int a = (int)Math.sqrt(count);
            points = new double[2*a*a][3];
            Point3d point = new Point3d();
            Vector3d pos_vector = new Vector3d();
            Transform3D trans = new Transform3D(this.transformrot);
            trans.setScale(1);
            for(int i = 0; i < a; i++){
                for(int ii = 0; ii < a; ii++){
                    pos_vector.set(((double)i/(a-1)-0.5)/1.1*this.breite,(((double)ii/(a-1)-0.5)/3)*this.hohe+(((double)i/(a-1)-0.5)/3)*this.hohe/a,Elektron.radius);
                    trans.transform(pos_vector);
                    points[ii+a*i][0] = this.pos.x+pos_vector.x;
                    points[ii+a*i][1] = this.pos.y+pos_vector.y;
                    points[ii+a*i][2] = this.pos.z+pos_vector.z;

                    pos_vector.set(((double)i/(a-1)-0.5)/1.1*this.breite,(((double)ii/(a-1)-0.5)/3)*this.hohe-(((double)i/(a-1)-0.5)/3)*this.hohe/a,-Elektron.radius);
                    trans.transform(pos_vector);
                    points[a*a+ii+a*i][0] = this.pos.x+pos_vector.x;
                    points[a*a+ii+a*i][1] = this.pos.y+pos_vector.y;
                    points[a*a+ii+a*i][2] = this.pos.z+pos_vector.z;
                }
            }
        }else if(this.breite >= 0.01){
            points = new double[count][3];
            Point3d point = new Point3d();
            point.set(0.5,-1./6.,0.0001);
            this.transformrot.transform(point);
            points[0][0] = this.pos.x+point.x;
            points[0][1] = this.pos.y+point.y;
            points[0][2] = this.pos.z+point.z;
            for(int i = 1; i < points.length; i++){
                point.set(Math.cos(i)/2,((double)i/(points.length-1)-0.5)/3,Math.sin(i)/2);
                this.transformrot.transform(point);
                points[i][0] = this.pos.x+point.x;
                points[i][1] = this.pos.y+point.y;
                points[i][2] = this.pos.z+point.z;
            }
        }else{
            points = new double[count][3];
            Point3d point = new Point3d();
            for(int i = 0; i < points.length; i++){
                point.set(Math.cos(i)/200,((double)i/(points.length-1)-0.5)/3,Math.sin(i)/200);
                Transform3D trans = new Transform3D(this.transformrot);
                trans.setScale(new Vector3d(1,trans.getScale(),1));
                trans.transform(point);
                points[i][0] = this.pos.x+point.x;
                points[i][1] = this.pos.y+point.y;
                points[i][2] = this.pos.z+point.z;
            }
        }
        return points;
    }
    /**@param precision Wird nur beim Zeichnen der Feldlinien und nur von PlateCharge ausgewertet. Beim Wert 0 wird der Parameter ignoriert.*/
    public boolean collided(Vektor3D position, double radius, int precision){
        Point3d point = new Point3d(position.x-this.pos.x,position.y-this.pos.y,position.z-this.pos.z);
        Transform3D trans = new Transform3D(this.transformrot);
        trans.setScale(1);
        trans.invert();
        trans.transform(point);
        double add = 0;
        if(precision > 0)
            add = .5/precision;
        if((Math.abs(point.z) <= this.tiefe/2+radius+add) && (Math.abs(point.x) <= this.breite/2+radius+add))
            return true;
        return false;
    }
    public String getSaveString(){
        return (this.specification+" Q = "+this.Q_As+" x = "+this.pos.x+" y = "+this.pos.y+" z = "+this.pos.z+" a = "+this.breite+" R = "+this.originalcolor.x+" G = "+this.originalcolor.y+" B = "+this.originalcolor.z+" emit = "+this.originalemitting+" fx = "+this.drehung.x+" fy = "+this.drehung.y+" fz = "+this.drehung.z+" ux = "+this.drehungoben.x+" uy = "+this.drehungoben.y+" uz = "+this.drehungoben.z);
    }
}
