/**3D-Vektor.
 * @author Oliver Barta
 * @version 1.0
 */
public class Vektor3D{
    public double x;
    public double y;
    public double z;
    /**Neuer Vektor mit (0,0,0).
     */
    public Vektor3D(){
        this.x = 0.;
        this.y = 0.;
        this.z = 0.;
    }
    /**Neuer Vektor mit (x,y,z)
     * @param x x-Wert
     * @param y y-Wert
     * @param z z-Wert
     */
    public Vektor3D(double x, double y, double z){
        this.x = x;
        this.y = y;
        this.z = z;
    }
    /**Neuer Vektor mit (point.x,point.y,point.z)
     * @param point x,y,z-Werte
     */
    public Vektor3D(double[] point){
        this.x = point[0];
        this.y = point[1];
        this.z = point[2];
    }
    /**Gibt den Betrag des Vektors zurck.
     * @return Betrag des Vektors
     */
    public double getAbs(){
        return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z);
    }
    /**Gibt die Werte des Vektors zurck.
     * @return Vektorwerte
     */
    public String toString(){
        return("Vektor ["+this.x+"/"+this.y+"/"+this.z+"]");
    }
    /**Addiert einen Vektor zu diesem Vektor und speichert das Ergebnis in this.
     * @param v zu addierender Vektor
     */
    public void addintern(Vektor3D v){
        this.x += v.x;
        this.y += v.y;
        this.z += v.z;
    }
    /**Addiert einen Vektor zu diesem Vektor.
     * @param v zu addierender Vektor
     * @return Summe der Vektoren
     */
    public Vektor3D add(Vektor3D v){
        return new Vektor3D(this.x+v.x, this.y+v.y, this.z+v.z);
    }
    /**Skaliert disen Vektor und speichert das Ergebnis in this.
     * @param k Faktor
     */
    public void scaleintern(double k){
        this.x *= k;
        this.y *= k;
        this.z *= k;
    }
    /**Skaliert diesen Vektor.
     * @param k Faktor
     * @return Skalarprodukt
     */
    public Vektor3D scale(double k){
        return new Vektor3D(this.x*k, this.y*k, this.z*k);
    }
    /**Setzt alle Werte dieses Vektors auf null
     */
    public void clear(){
        this.x = 0.;
        this.y = 0.;
        this.z = 0.;
    }
}
